/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * NurseFrame.java
 *
 * Created on Oct 3, 2008, 5:29:39 PM
 */

package net.ponder2.nurse;

import java.beans.PropertyChangeListener;
import java.util.HashMap;
import java.util.Map;

import javax.swing.BoxLayout;
import javax.swing.JLabel;

/**
 * 
 * @author kevin
 */
public class NurseFrame extends javax.swing.JFrame {

  private JLabel logPanel;

  /** Creates new form NurseFrame */
  public NurseFrame(String name) {
    initComponents();
    setTitle("Nurse " + name);
  }

  private void initComponents() {

    jLabel1 = new javax.swing.JLabel();
    jLabel2 = new javax.swing.JLabel();
    jLabel3 = new javax.swing.JLabel();
    jLabel4 = new javax.swing.JLabel();
    bsnPanel = new javax.swing.JPanel();
    logPanel = new javax.swing.JLabel();

    setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

    jLabel1.setText("Nurse Station");

    jLabel2.setText("Name");

    jLabel3.setText("Value");

    jLabel4.setText("Scan Rate");

    org.jdesktop.layout.GroupLayout bsnPanelLayout = new org.jdesktop.layout.GroupLayout(bsnPanel);
    bsnPanel.setLayout(new BoxLayout(bsnPanel, BoxLayout.PAGE_AXIS));
    bsnPanelLayout.setHorizontalGroup(
        bsnPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
        .add(0, 316, Short.MAX_VALUE)
    );
    bsnPanelLayout.setVerticalGroup(
        bsnPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
        .add(0, 100, Short.MAX_VALUE)
    );

    logPanel.setText("");

    org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
    getContentPane().setLayout(layout);
    layout.setHorizontalGroup(
        layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
        .add(layout.createSequentialGroup()
            .addContainerGap()
            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                .add(jLabel1)
                .add(layout.createSequentialGroup()
                    .add(19, 19, 19)
                    .add(jLabel2)
                    .add(48, 48, 48)
                    .add(jLabel3)
                    .add(44, 44, 44)
                    .add(jLabel4))
                .add(bsnPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(logPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
            .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
    );
    layout.setVerticalGroup(
        layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
        .add(layout.createSequentialGroup()
            .addContainerGap()
            .add(jLabel1)
            .add(18, 18, 18)
            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                .add(jLabel2)
                .add(jLabel4)
                .add(jLabel3))
            .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
            .add(bsnPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
            .add(logPanel)
            .addContainerGap(207, Short.MAX_VALUE))
    );

    pack();
}// </editor-fold>


  /**
   * @param args
   *          the command line arguments
   */
  public static void main(String args[]) {
    java.awt.EventQueue.invokeLater(new Runnable() {

      public void run() {
        new NurseFrame("Test").setVisible(true);
      }
    });
  }

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel bsnPanel;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JLabel jLabel3;
  private javax.swing.JLabel jLabel4;
  // End of variables declaration//GEN-END:variables

  Map<String, BsnPanel> bsns = new HashMap<String, BsnPanel>();

  /**
   * @param name
   */
  public BsnPanel addBsn(String name, PropertyChangeListener nurse) {
    synchronized (bsns) {
      BsnPanel bsn = bsns.get(name);
      if (bsn != null)
        return bsn;
      bsn = new BsnPanel();
      bsn.setBsnName(name);
      bsnPanel.add(bsn);
      bsns.put(name, bsn);
      bsn.addPropertyChangeListener("BsnRate", nurse);
      return bsn;
    }
  }

  public void removeBsn(String name) {
    synchronized (bsns) {
      BsnPanel bsn = bsns.get(name);
      if (bsn != null) {
        bsns.remove(name);
        bsnPanel.remove(bsn);
        pack();
      }
    }
  }

  public void log(String msg) {
    logPanel.setText(msg);
  }
}
